/*
 * PaintBoard2D.java
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class PaintBoard2D extends JFrame implements ActionListener {

	JButton	b;
	Color	color;

  public PaintBoard2D()
  {
    super( "Paint Board" );

    // add components
    Container cp = getContentPane();
    cp.add( new Board(), BorderLayout.CENTER );
    cp.add( (b = new JButton("Change Color")), BorderLayout.SOUTH );
    b.addActionListener( this );

    // set default draw color to be red
    color = Color.red;

    setSize( 400, 400 );
    setLocationRelativeTo( null );
    setDefaultCloseOperation( EXIT_ON_CLOSE );
  }

  public void actionPerformed( ActionEvent e )
  {
    Color c = JColorChooser.showDialog( this, "Choose Color", color );
    if( c != null ) color = c;
    repaint();
  }

  public static void main( String args[] )
  {
    PaintBoard2D p = new PaintBoard2D();
    p.show();
  }

  // A customized panel where we can paint on.
  class Board extends JPanel {

    public void paint( Graphics g )
    {
      super.paint(g);

      int w = getWidth();
      int h = getHeight();

      Graphics2D g2 = (Graphics2D) g;

      g2.drawLine( 0, 0, w-1, h-1 );
      g2.drawLine( w-1, 0, 0, h-1 );

      g2.drawRect( w/8, h/8, w/4, h/4 );
      g2.drawOval( 5*w/8, h/8, w/4, h/4 );
      g2.fillRect( 5*w/8, 5*h/8, w/4, h/4 );
      g2.fillOval( w/8, 5*h/8, w/4, h/4 );
    }

  } // end of class Board

} // end of class PaintBoard2D

